#! /usr/bin/env python

#
# Copyright (C) 2004  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import string
from dvbobjects.utils import *
from dvbobjects.utils.MJD import *
from dvbobjects.MPEG.Descriptor import Descriptor

######################################################################
class tds_frequency_item(DVBobject):

    def pack(self):
        self.freq7 = (self.freq * 7) + 1
        fmt = "!H"
        return pack(fmt, self.freq7)

class terrestrial_delivery_system_descriptor(Descriptor):

    descriptor_tag = 0xfa

    def bytes(self):
        frequency_bytes = string.join(
                map(lambda x: x.pack(), 
                self.frequencies),
                "")
            
        fmt = "!H%ds" % len(frequency_bytes)
        return pack(fmt, 
	                ((self.area_code & 0xFFF) << 4) | 
	                ((self.guard_interval & 0x3) << 2) | 
	                (self.transmission_mode & 0x3) , 
            	    frequency_bytes
	                )

######################################################################
class partial_reception_descriptor(Descriptor):

    descriptor_tag = 0xfb

    def bytes(self):       

        fmt = "!H"
        return pack(fmt, self.service_id)

######################################################################
class system_management_descriptor(Descriptor):

    descriptor_tag = 0xfe

    def bytes(self):
        fmt = "!BB" 
        self.broadcasting_identifier = 3 # ISDB System
        self.additional_broadcasting_information = 1
        return pack(fmt,
                    (self.broadcasting_flag << 6 | self.broadcasting_identifier),
                    self.additional_broadcasting_information,
                    )
		    
######################################################################

